#!/usr/bin/env python
# -*- coding: utf-8 -*-

## Binary Analysis Tool
## Copyright 2016 Andrei Costin (andrei@firmware.re) for Firmware.RE
## Licensed under Apache 2.0, see LICENSE file for details

import sys
import msl.utils.lua_parser_json

# TODO: patch extractidentifiers()
# if (newlanguage in ['Lua']):
#   # TODO
# if (newlanguage in ['C', 'C#', 'Java', 'PHP', 'Python', 'Ruby']):
#   p2 = subprocess.Popen(["ctags",

# TODO: patch extractsourcestrings()
# if language == 'Lua':
#   # TODO
# else:
#   p1 = subprocess.Popen(['xgettext'


# Based on parsepython() in https://raw.githubusercontent.com/armijnhemel/binaryanalysis/master/src/maintenance/createdb.py
def parselua((filedir, filepath, unpackdir)):
	comments = []
	strings = []
	pathname = os.path.join(filedir, filepath)

	returndict = {}
	
	luajsonres = lua_get_json([pathname])
	
	if luajsonres != None:
	    comments = luajsonres.get("comments", [])
	    strings = luajsonres.get("strings", [])

	if comments != [] or strings != []:
		commentsfile = None
		stringsfile = None

		if comments != []:
			## there are comments, so print them to a file
			commentsfile = tempfile.mkstemp(dir=unpackdir)
			for c in [entry["text"] for entry in comments if "text" in entry.keys()]:
				os.write(commentsfile[0], c)
				os.write(commentsfile[0], "\n")
			os.fdopen(commentsfile[0]).close()
			commentsfile = os.path.basename(commentsfile[1])

		if strings != []:
			## there are strings, so print them to a file
			stringsfile = tempfile.mkstemp(dir=unpackdir)
			for c in [entry["text"] for entry in strings if "text" in entry.keys()]:
				os.write(stringsfile[0], c)
				os.write(stringsfile[0], "\n")
			os.fdopen(stringsfile[0]).close()
			stringsfile = os.path.basename(stringsfile[1])

		returndict = {'unpackdir': unpackdir, 'commentsfile': commentsfile, 'stringsfile': stringsfile}

		return (filedir, filepath, returndict)	

	return None


if __name__ == '__main__':
    # TODO: Implement self-tests/unit-tests
    sys.exit(0)


