#!/usr/bin/env python
# -*- coding: utf-8 -*-

## MoonShineLua (MSL)
##
## Copyright 2016 Andrei Costin (andrei@firmware.re) for Firmware.RE
## with support from Tjaldur Software Governance Solutions and NLnet.nl.
##
## See LICENSE file for details.

import re

# TODO: add all supported vuln type
DEFAULT_VULN_SET = set(["xss", "cmdi", "sqli", "pathtrav", "fileenum", "nullbyte", "lfi", ])

# Default entry values
config_entry = {
    "id": "", 
    # NOTE: Do not replace with "", because we need a re object here so that we can consistently call something like: some_node_state["match"].match(some_token)
    "match": re.compile("^$"), 
    "desc": "", 
    "ref": "", 
    "notes": "", 
    "is_tainted": False, 
    "taint_types": set([]),
    "passthru": set([]), 
    "unsanitize": set([]), 
    "sanitize": set([]), 
    "sensitive": set([]), 
}

def get_security_attributes(token, db):
    for conf in db:
        # We use dictionary .get() with a default empty regex to make sure that missconfigured/incomplete config entries do not affect us much
        regex = conf.get("match", re.compile("^$"))
        if regex.match(token):
            return dict(conf)
    return dict(config_entry)

