#!/usr/bin/env python
# -*- coding: utf-8 -*-

## MoonShineLua (MSL)
##
## Copyright 2016 Andrei Costin (andrei@firmware.re) for Firmware.RE
## with support from Tjaldur Software Governance Solutions and NLnet.nl.
##
## See LICENSE file for details.

import antlr4
from antlr4 import *
from msl.parsing.luapages.LuaPagesHTMLLexer import LuaPagesHTMLLexer
from msl.parsing.luapages.LuaPagesHTMLParser import LuaPagesHTMLParser
import msl.utils.encodings as encodings

import sys
import os
import pprint

if __name__ == '__main__':
    for f in sys.argv[1:]:
        for encoding in encodings.list_encodings_top() + encodings.list_encodings_all():
            try:
                input = FileStream(fileName = f, encoding = encoding)
                lexer = LuaPagesHTMLLexer(input)
                channel = Token.DEFAULT_CHANNEL
                stream = CommonTokenStream(lexer, channel = channel)
                parser = LuaPagesHTMLParser(stream)
                cst_parse_tree = parser.htmlDocument()

            except Exception, ex:
                print >> sys.stderr, ex

            print "Parsed", f, encoding
            break

