#!/usr/bin/env python
# -*- coding: utf-8 -*-

## MoonShineLua (MSL)
##
## Copyright 2016 Andrei Costin (andrei@firmware.re) for Firmware.RE
## with support from Tjaldur Software Governance Solutions and NLnet.nl.
##
## See LICENSE file for details.


'''
Common and utility functionality fo the unit tests for MSL.
'''

import errno
import os
import sys

TMP_TESTS_PREFIX = "./tests/msl_tests_dumps"
TMP_TESTS_DIR_PATTERN       = "%s/%s/"
TMP_TESTS_FNAME_PATTERN     = "%s/%s/%s.lua"

# http://stackoverflow.com/a/600612
def mkdir_p(path):
    try:
        os.makedirs(path)
    except OSError as exc:  # Python >2.5
        if exc.errno == errno.EEXIST and os.path.isdir(path):
            pass
        else:
            raise

def get_tests_dir_prefix():
    dir_prefix = os.getenv("MSLPATH", "./")
    dir_prefix_realpath = os.path.realpath(dir_prefix)
    return (dir_prefix, dir_prefix_realpath)


def dump_test_code(dir_realpath, clsname, fname, code):
    try:
        tmp_dir = os.path.normpath(os.path.join(dir_realpath, TMP_TESTS_DIR_PATTERN % (TMP_TESTS_PREFIX, clsname)))
        tmp_fname = os.path.normpath(os.path.join(dir_realpath, TMP_TESTS_FNAME_PATTERN % (TMP_TESTS_PREFIX, clsname, fname)))
        mkdir_p(tmp_dir)
        with open(tmp_fname, "w") as tmp_fhandle:
            tmp_fhandle.write(code)
        return tmp_fname
    except Exception, ex:
        print >> sys.stderr, ex
        return None

    return None
