#!/usr/bin/env python
# -*- coding: utf-8 -*-

## MoonShineLua (MSL)
##
## Copyright 2016 Andrei Costin (andrei@firmware.re) for Firmware.RE
## with support from Tjaldur Software Governance Solutions and NLnet.nl.
##
## See LICENSE file for details.


'''
Unit tests for MSL.
'''

import os
import sys
import unittest
import msl.tests.common as commontests
import msl.config.defaultconfig as defaultconfig

class DefaultConfigTests(unittest.TestCase):
    ############################################################################
    def setUp(self):
        self.clsname = self.__class__.__name__
        self.fname = sys._getframe().f_code.co_name

    ############################################################################
    def test_config_db_positive1(self):
        assert("xss" in defaultconfig.config_db_as_dict["cgilua.QUERY"]["taint_types"].intersection(defaultconfig.config_db_as_dict["cgilua.put"]["sensitive"]))
        assert("cmdi" not in defaultconfig.config_db_as_dict["cgilua.QUERY"]["taint_types"].intersection(defaultconfig.config_db_as_dict["cgilua.put"]["sensitive"]))
        assert("cmdi" in defaultconfig.config_db_as_dict["cgilua.QUERY"]["taint_types"].intersection(defaultconfig.config_db_as_dict["io.popen"]["sensitive"]))
        assert("xss" not in defaultconfig.config_db_as_dict["cgilua.QUERY"]["taint_types"].intersection(defaultconfig.config_db_as_dict["io.popen"]["sensitive"]))

    ############################################################################
    def test_config_db_negative1(self):
        assert("xss" not in defaultconfig.config_db_as_dict["cgilua.QUERY"]["taint_types"].intersection(defaultconfig.config_db_as_dict["cgilua.put"]["sensitive"]))

    def test_config_db_negative2(self):
        assert("cmdi" in defaultconfig.config_db_as_dict["cgilua.QUERY"]["taint_types"].intersection(defaultconfig.config_db_as_dict["cgilua.put"]["sensitive"]))

    def test_config_db_negative3(self):
        assert("cmdi" not in defaultconfig.config_db_as_dict["cgilua.QUERY"]["taint_types"].intersection(defaultconfig.config_db_as_dict["io.popen"]["sensitive"]))

    def test_config_db_negative4(self):
        assert("xss" in defaultconfig.config_db_as_dict["cgilua.QUERY"]["taint_types"].intersection(defaultconfig.config_db_as_dict["io.popen"]["sensitive"]))

    ############################################################################
    def tearDown(self):
        self.clsname = None
        self.fname = None


def suite():
    suites = [DefaultConfigTests, ]
    suite = unittest.TestSuite()
    for s in suites:
        suite.addTest(unittest.makeSuite(s))
    return suite


if __name__ == '__main__':
    unittest.main(defaultTest='suite')


