#!/usr/bin/env python
# -*- coding: utf-8 -*-

## MoonShineLua (MSL)
##
## Copyright 2016 Andrei Costin (andrei@firmware.re) for Firmware.RE
## with support from Tjaldur Software Governance Solutions and NLnet.nl.
##
## See LICENSE file for details.

import sys
import pprint
import chardet


# http://stackoverflow.com/a/3323810
# http://stackoverflow.com/a/1779263
def guess_file_encoding(filename):
    """Tries to guess the encoding of the file specified by the filename.
    
    Tries to guess the encoding of the file specified by the filename.
    
    Parameters
    ----------
    filename : str
               Filename of a file for which we want to know/guess it's 
               encoding.

    Returns
    -------
    result : dictionary
             Dictionary containing
             `encoding` key specifying the guessed encoding string
             `confidence` key specifying the confidence level of the guess
             or {} empty on Error.
    """

    try:
        rawdata = open(filename, "r").read()
        result = chardet.detect(rawdata)
        return result
    except Exception, ex:
        pass

    return {}


# https://docs.python.org/2/library/codecs.html
def list_encodings_top():
    return ["utf-8", "ascii", "iso-8859-1", "iso-8859-2", "windows-1251"]


# http://stackoverflow.com/a/25584253
def list_encodings_all():
    return ["ascii",
 "big5",
 "big5hkscs",
 "cp037",
 "cp424",
 "cp437",
 "cp500",
 "cp720",
 "cp737",
 "cp775",
 "cp850",
 "cp852",
 "cp855",
 "cp856",
 "cp857",
 "cp858",
 "cp860",
 "cp861",
 "cp862",
 "cp863",
 "cp864",
 "cp865",
 "cp866",
 "cp869",
 "cp874",
 "cp875",
 "cp932",
 "cp949",
 "cp950",
 "cp1006",
 "cp1026",
 "cp1140",
 "cp1250",
 "cp1251",
 "cp1252",
 "cp1253",
 "cp1254",
 "cp1255",
 "cp1256",
 "cp1257",
 "cp1258",
 "euc_jp",
 "euc_jis_2004",
 "euc_jisx0213",
 "euc_kr",
 "gb2312",
 "gbk",
 "gb18030",
 "hz",
 "iso2022_jp",
 "iso2022_jp_1",
 "iso2022_jp_2",
 "iso2022_jp_2004",
 "iso2022_jp_3",
 "iso2022_jp_ext",
 "iso2022_kr",
 "latin_1",
 "iso8859_2",
 "iso8859_3",
 "iso8859_4",
 "iso8859_5",
 "iso8859_6",
 "iso8859_7",
 "iso8859_8",
 "iso8859_9",
 "iso8859_10",
 "iso8859_13",
 "iso8859_14",
 "iso8859_15",
 "iso8859_16",
 "johab",
 "koi8_r",
 "koi8_u",
 "mac_cyrillic",
 "mac_greek",
 "mac_iceland",
 "mac_latin2",
 "mac_roman",
 "mac_turkish",
 "ptcp154",
 "shift_jis",
 "shift_jis_2004",
 "shift_jisx0213",
 "utf_32",
 "utf_32_be",
 "utf_32_le",
 "utf_16",
 "utf_16_be",
 "utf_16_le",
 "utf_7",
 "utf_8",
 "utf_8_sig"]


if __name__ == '__main__':
    for f in sys.argv[1:]:
        print f, guess_file_encoding(f)


