#!/usr/bin/env python
# -*- coding: utf-8 -*-

## MoonShineLua (MSL)
##
## Copyright 2016 Andrei Costin (andrei@firmware.re) for Firmware.RE
## with support from Tjaldur Software Governance Solutions and NLnet.nl.
##
## See LICENSE file for details.

'''
Common utility functionality for MSL.
'''

# http://stackoverflow.com/a/30902807
def longest_list(l):
    if(not isinstance(l, list)): return(0)
    return(max([len(l),] + [len(subl) for subl in l if isinstance(subl, list)] + [longest_list(subl) for subl in l]))

def get_object_id(o):
    return ("%s_%s" % (hex(id(o)), hex(hash(o)))).replace("-", "")
    #return ("%s_%s" % (hex(id(o)), hex(id(o)))).replace("-", "")

def export_tlib_to_dot(tlib_tree, fname = '/tmp/tree.dot'):
    # Generate a Graphviz DOT file for vizualisation/printing
    # https://github.com/caesar0301/treelib/issues/52
    import treelib
    from treelib.plugins import export_to_dot
    export_to_dot(tlib_tree, fname)
    # NOTE: To use the generated Graphviz DOT file, run below commands in bash/shell
    # xdot /tmp/tree.dot
    # dot -Tps /tmp/tree.dot -o /tmp/tree.ps
    # evince /tmp/tree.ps

